// PIC16F1455gv
// [XMɂA\
// 12MHz Uqgp
/**	INCLUDES *******************************************************/
#include "usb.h"
#include "usb_function_cdc.h"
#include "HardwareProfile.h"

#include <htc.h>

#pragma	config FCMEN  =	OFF
#pragma	config IESO	  =	OFF
#pragma	config CLKOUTEN	=	OFF
#pragma	config BOREN  =	OFF
#pragma	config CP	  =	OFF
#pragma	config MCLRE  =	OFF
#pragma	config PWRTE =	ON
#pragma	config WDTE	 =	OFF
#pragma	config FOSC	  =	HS		// HS
#pragma	config LVP	  =	ON		// must
#pragma	config BORV	  =	1
#pragma	config STVREN =	ON
#pragma	config PLLEN  =	1
#pragma	config PLLMULT	=	0	// 12MHz x 4
#pragma	config USBLSCLK	=	1
#pragma	config CPUDIV  =	0
#pragma	config WRT	  =	OFF


/**	I N	C L	U D	E S	**********************************************************/

#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "usb_config.h"
#include "usb_device.h"
#include "usb.h"


/**	V A	R I	A B	L E	S ********************************************************/
#if	defined(__18CXX)
#pragma	udata
#endif
char USB_Out_Buffer[CDC_DATA_OUT_EP_SIZE];
char SIO_Out_Data[CDC_DATA_IN_EP_SIZE];

unsigned char  NextUSBOut;
unsigned char	 NextUSBOut;
//char SIO_In_Data;
unsigned char	 LastSIOOut;  // Number	of characters in the buffer
unsigned char	 SIOcp;		  // current position within the buffer
unsigned char SIO_Out_Data_Rdy = 0;
USB_HANDLE	lastTransmission;

//BOOL stringPrinted;
BOOL RC5_old;

/**	P R	I V	A T	E  P R O T O T Y P E S ***************************************/
void ProcessIO(void);
void USBDeviceTasks(void);
void USBCBSendResume(void);
void UserInit(void);
void putc_ob_buffer(char c);
void putc_ib_buffer(char c);
unsigned char getc_ib_buffer();
unsigned char getc_ob_buffer();
unsigned char asc2num(unsigned char);
void printn();
void printfn8();
void printd8();
void clr_com_buf();
void clr_com_para();
void clr_ob_buffer();
void parse();
void exec_command();
void settime();
void crlf();
void sp();
void lf();

void disp(void);
void mores_out(unsigned char);
void short_out();				// . output
void long_out();				// - output
void interval_act();			// wait intervla .. or -. or .- or --
void interval_character();		// wait interval charactor
void interval_word();			// wait interval word
unsigned char mores_table_pulse(unsigned char);
unsigned char mores_table_mask(unsigned char);

unsigned char chk_ob_buffer_not_full();
unsigned char chk_ib_buffer_not_empty();
unsigned char chk_ib_buffer_not_full();
unsigned char chk_ob_buffer_not_empty();
void sputs(	const char *);
unsigned char inch();
void outchar( unsigned char	);
void echo(void);
void timep(void);
unsigned char check_rx();
void m_wait(void);		// delay about 22mSec
void l_wait(void);		// delay about 699mSec


unsigned char year;
unsigned char month;			
unsigned char date;			
unsigned char hour;			
unsigned char min;
unsigned char sec;
unsigned char usb_flag;

unsigned char ob_buffer[0x80];		//obó@f[^obt@
unsigned char ob_wp;				//|C^
unsigned char ob_rp;				//|C^
unsigned char ib_buffer[0x80];		//ob́@f[^obt@
unsigned char ib_wp;
unsigned char ib_rp;

unsigned char com_buf[0x20];
unsigned char com_buf_p;
unsigned char command;				// R}hP
unsigned char parameter[0x10];
unsigned char parameter_count;
unsigned char hour;					// 
unsigned char min;					// 
unsigned char sec;					// b
unsigned char sub_sec;				// 1/100 b
unsigned char sec_flag;

unsigned char adjust_val = 55;
int adjust_timer;

	void interrupt timer2_int()
	{
		if(TMR2IF = 1){
			TMR2IF = 0;
			sub_sec = sub_sec + 1;					// sec
			adjust_timer ++;
			if(adjust_timer == 10050){
				sub_sec = adjust_val;
				adjust_timer = 0;
			}
			if(sub_sec == 100){
				sub_sec = 0;
				sec = sec + 1;
				sec_flag = 1;
				if(sec == 60){
					sec = 0;
					min = min + 1;				// min
					if(min == 60){
						min = 0;
						hour = hour + 1;		// hour
						if(hour == 24){
							hour = 0;
						}
					}
				}
			}
		}
	}

/******************************************************************************
 * Function:		void main(void)
 *
 * PreCondition:	None
 *
 * Input:			None
 *
 * Output:			None
 *
 * Side	Effects:	None
 *
 * Overview:		Main program entry point.
 *
 * Note:			None
 *****************************************************************************/
int	main(void)
{	

	UserInit();
	adjust_timer = 0;
	
//	USBDeviceAttach();
	clr_com_buf();
	clr_com_para();
	while(1){
		USBDeviceTasks(); 
		ProcessIO();
		if(	check_rx() != 0x00){
			parse();
			exec_command();
		}
	}
}



//---------------------------------------------------------------
//--- execute command -------------------------------------------
//---------------------------------------------------------------

void exec_command()
{
	if(	command	== 's'){settime();}
	if(	command	== 'e'){echo();}
	if(	command	== 't'){timep();}
	if(	command	== 'd'){disp();}
	clr_com_buf();
	clr_com_para();
	clr_ob_buffer();
}

//--- command ---------------------------------------------------
//--- echo back -------------------------------------------------

void echo(void)
{
	unsigned char b_data;
	unsigned char n;
	crlf();
	for(n =	0; n < com_buf_p; n++){
		b_data = com_buf[n];
		outchar(b_data);
	}
	crlf();
}


//--- command ---------------------------------------------------
//--- print RTC time --------------------------------------------

void timep(void)
{
	unsigned char rtc_data[7];
	
	crlf();
//	sputs("time	= ");

	printd8(hour);	sp();
	printd8(min);	sp();
	printd8(sec);	sp();
	crlf();
}


//--- command ---------------------------------------------------
//--- LED mores display -----------------------------------------

void disp()
{
	unsigned char s,s2;
	unsigned char m,mu,ml;
	unsigned char h,hu,hl;
	int t;
	crlf();
	l_wait();
	clr_com_buf();
	clr_com_para();
	clr_ob_buffer();
	t = 0;
	while(1){
		if(sec_flag == 1){
			sec_flag = 0;
			t++;	// interval 10S
		}
		if(t == 5){
			t = 0;
			h = hour;
			m = min;
			hu = 0;
			hl = 0;
			if(h > 9){ h = h - 10; hu ++;}
			if(h > 9){ h = h - 10; hu ++;}
			hl = h ;
			mu = 0;
			ml = 0;
			if(m > 9){ m = m - 10; mu ++;}
			if(m > 9){ m = m - 10; mu ++;}
			if(m > 9){ m = m - 10; mu ++;}
			if(m > 9){ m = m - 10; mu ++;}
			if(m > 9){ m = m - 10; mu ++;}
			ml = m;

			mores_out(hu);
			mores_out(hl);	
			mores_out(mu);	
			mores_out(ml);	
		}
			USBDeviceTasks(); 
			ProcessIO();
		if(	check_rx() != 0x00){ crlf(); return;}
	}
}


void mores_out(unsigned char num)	
{
	unsigned char pattern;
	unsigned char n;

	pattern = mores_table_pulse(num);

	for(n = 0 ; n < 5 ; n++){
		if((pattern & 0x10) == 0x00){
			short_out();
		}
		else{
			long_out();
		}
		interval_act();
		pattern = pattern << 1;
	}
		interval_character();
}

void short_out()
{
unsigned char n;
	RC1 = 0;
	for(n = 0 ; n < 9 ; n++ ){
		m_wait();
	}
	RC1 = 1;
}

void long_out()
{
unsigned char n;
	RC1 = 0;

	for(n = 0 ; n < 9 ; n++ ){
		m_wait();
		m_wait();
		m_wait();
	}
	RC1 = 1;
}




void interval_act()
{
unsigned char n;
	for(n = 0 ; n < 9 ; n++ ){
		m_wait();
	}
}

void interval_character()
{
unsigned char n;
	for(n = 0 ; n < 9 ; n++ ){
		m_wait();
		m_wait();
		m_wait();
	}
}

rom const unsigned char pulse[] = {0x1f,0x0f,0x07,0x03,0x01,0x00,0x10,0x18,0x1c,0x1e};

unsigned char mores_table_pulse(unsigned char num)
{
	return(pulse[num]);
}

//-----------------------------------------------------------------
// 0 = -----		 (0x1f)
// 1 = .----         (0x0f)
// 2 = ..---         (0x07)
// 3 = ...--         (0x03)
// 4 = ....-         (0x01)
// 5 = .....         (0x00)
// 6 = -....         (0x10)
// 7 = --...         (0x18)
// 8 = ---..         (0x1c)
// 9 = ----.         (0x1e)


//--- command ---------------------------------------------------
//--- set time	-------------------------------------------------
void settime(){
	unsigned char b_data;
	unsigned char num_l;
	unsigned char num_u;
	unsigned char num;
	unsigned char order;

	crlf();
	order =	0;
	for(;;){
		parameter_count	= parameter_count -	1;	// sec
		if(parameter_count == 0xff) return;
		b_data = parameter[parameter_count];
		num_l =	asc2num(b_data);

		parameter_count	= parameter_count -	1;
		if(parameter_count == 0xff) return;
		b_data = parameter[parameter_count];
		num_u =	asc2num(b_data);

		num	= (num_u * 10) + num_l;
		order =	order +	1;
		if(order ==	1){	sec	= num;}
		if(order ==	2){ min = num;}
		if(order ==	3){ hour = num; break;}
	}
	sub_sec = 0;
	printd8(hour);
	sp();
	printd8(min);
	sp();
	printd8(sec);
	crlf();
}


//--- check	rx status -------------------------------------------
//--- data filled buffer ->	return(1) ---------------------------
unsigned char check_rx(){
	unsigned char b_data;
	b_data = 0xff;
	if(chk_ob_buffer_not_empty() ==	1){
		b_data = inch();
		outchar(b_data);
		com_buf[com_buf_p] = b_data;
		com_buf_p =	com_buf_p +	1;
		if(com_buf_p > 0x20){
			clr_com_buf();			// over	flow
			return(0);
		}
	}
	if(b_data == 0x0d) return(1);
	if(b_data == 0x0a) return(1);
	return(0); 
}


//--- command parser --------------------------------------------
void parse(){
	unsigned char n;
	unsigned char i;
	unsigned char b_data;

		command	= 0x00;
	for(n =	0;n	< 0x10;	n++){
		parameter[n] = 0x00;
	}

	n =	0;
	for(;;){
		b_data = com_buf[n];
		if(b_data != 0x20) break;	//skip space
		n++;
		if(n > 0x20) return;
	}
		if(b_data == 0x0d) return;	//	cr
		if(b_data == 0x0a) return;	//	lf
		if(b_data == 0x00) return;	//	null

		command	= b_data;
		n++;
	for(;;){
		b_data = com_buf[n];
		if(b_data != 0x20) break;	//skip space
		n++;
		if(n > 0x20) return;
	}
	i =	0;
	for(;;){
		b_data = com_buf[n];
		if((b_data < 0x3a) && (b_data >	0x2f)){		// parameter ->	parameter[]
			parameter[i] = b_data;
			i++;
			parameter_count	= i;
		}
		if(b_data == 0x0d) return;	//	cr
		if(b_data == 0x0a) return;	//	lf
		if(b_data == 0x00) return;	//	null
		if(b_data == 0x20) return;	//	space
		n++;
		if(n > 0x20) return;
	}
}


//--- clear	command	and	parameter---------------------------------
void clr_com_para(){
	unsigned char n;

		command	= 0x00;
	for(n =	0;n	< 0x10;	n++){
		parameter[n] = 0x00;
	}
		parameter_count	= 0;
}

//--- clear	com	buffer -----------------------------------------
void clr_com_buf(){
	unsigned char n;

	for(n =	0 ;	n <	0x20 ; n++){
		com_buf[n] = 0;
	}
	com_buf_p =	0;
}


//--- translate	ascii code to number ---------------------------
unsigned char asc2num(unsigned char	code)
{
	switch(code){
		case '0':	return(0);
		case '1':	return(1);
		case '2':	return(2);
		case '3':	return(3);
		case '4':	return(4);
		case '5':	return(5);
		case '6':	return(6);
		case '7':	return(7);
		case '8':	return(8);
		case '9':	return(9);
		case 'a':	return(10);
		case 'b':	return(11);
		case 'c':	return(12);
		case 'd':	return(13);
		case 'e':	return(14);
		case 'f':	return(15);
		default	:	return(0xff);
	}
}


//--- print	nibble number ------------------------------------
void printn( data )
unsigned char data;
{
unsigned char code ;
unsigned char b_data ;
	b_data = data &	0x0f;		// nibble mask
	if(b_data <= 9)
		code = '0' + b_data;
	else
		code = 'A' + b_data	- 0x0a;
	outchar(code);
}


//--- print	byte number	------------------------------------
void printfn8(data)
unsigned char data;
{
	unsigned char nibble ;
		nibble = (data >> 4);	// upper 4bit
		printn(nibble);

		nibble = data;			// lower 4bit
		printn(nibble);
}

//--- print	8bit number	by OCTAL ----------------------------
void printd8(data)
unsigned char data;
{
unsigned char p0,p1;
	p1 = 0;
	p0 = data;
	for(;;){
		if(p0 <	10)break;		// mod 10
		p0 = p0	- 10;
		p1 = p1	+ 1;
	}
	printn(p1);
	printn(p0);
}

void crlf(){
	outchar(0x0a);
	outchar(0x0d);
}

void lf(){
	outchar(0x0d);
}

void sp(){
	outchar(0x20);
}

void sputs(	const char *line )
{
	while( *line !=	'\0' ){
			outchar( *line );
			line++ ;
	}
}


unsigned char inch()
{
	unsigned char r_data;

	for(;;){
		if(chk_ob_buffer_not_empty() ==	0x01) break;
	}
	r_data = getc_ob_buffer();
	return(r_data);
}

void clr_ob_buffer()
{
	for(;;){
		if(chk_ob_buffer_not_empty() ==	0x00) return;
		getc_ob_buffer();
	}
}


void outchar( unsigned char	data )
{
//	for(;;){
//		if(chk_ib_buffer_not_full()	== 0x01) break;
//	}

	USBDeviceTasks(); 
	ProcessIO();
	putc_ib_buffer(data);
}


void UserInit(void)
{
	unsigned char i;
	char n;

// RC0 = RFU INPUT 
// RC1 = GPO LED GREEN
// RC2 = GPO LED RED
// RC3 = RFU INPUT
// RC4 = RFU INPUT
// RC5 = RFU INPUT
// RA3 = MCLR INPUT
// RA4 = XTAL OSC2(OUT)
// RA5 = XTAL OSC1(IN)
	OSCCON = 0x80;	 //	PLL	enabled, 4x, 31kHz, SCS config

	ANSELA =	0x00;
	ANSELC =	0x00;
	TRISA =	0x20;	/* RA5 as input RA4 as output */
	TRISC =	0xF9;	/* RC2,RC1 as output */
	PORTA =	0xFF;
	PORTC =	0xFF;

	OPTION_REG = 0x7F;
	m_wait();
	usb_flag = 0x00;
	RC1 = 1;
	asm("nop");
	RC2 = 1;

	USBDeviceInit();

//	 Initialize	the	arrays
	for	(i=0; i<sizeof(USB_Out_Buffer);	i++)
	{
		USB_Out_Buffer[i] =	0;
	}

	NextUSBOut = 0;
	LastSIOOut = 0;
	lastTransmission = 0;

	ob_wp =	0;
	ob_rp =	0;
	ib_wp =	0;
	ib_rp =	0;

	hour = 0;
	min = 0;
	sec = 0;
	sub_sec = 0;
	TMR2 = 0;
	T2CON = 0x77;		// timmer2 (((12M / 4) / 64) / 15)
	PR2 = 124;			// 125 * 100 * 15 * 64 * 4 = 48M
	TMR2IE = 1;
	PEIE = 1;
	GIE = 1;

}//end UserInit

void m_wait()
{
	unsigned char n;
	for(n =	0 ;	n <	4 ;	n++){
		OPTION_REG = 0x07;		// source =	FOSC/4 prescaler = 256
		TMR0IF = 0;
		TMR0 = 0x00;
		for(;;){
			if(TMR0IF == 1)	break;		// about 5.46mS	delay
		}
	}
}


void l_wait()
{
	unsigned char n;
	for(n =	0 ;	n <	0x50 ; n++){
		m_wait();
	}
}


// ob@f[^obt@`FbN
unsigned char chk_ib_buffer_not_empty()
{
	if(ib_wp ==	ib_rp) return(0);		//wrrd̃|C^v
	return(1);
}

// ob@f[^obt@`FbN
unsigned char chk_ib_buffer_not_full()
{
	unsigned char w1;
	unsigned char r1;
	w1 = ib_wp;
	r1 = ib_rp;
	w1 = w1	+ 1;	//̃ANZXŃ|C^v
	w1 = w1	& 0x7f;
	if(w1 == r1) return(0);
	return(1);
}


// ob@f[^obt@`FbN
unsigned char chk_ob_buffer_not_empty()
{
	if(ob_wp ==	ob_rp) return(0);		//wrrd̃|C^v
	return(1);
}

// ob@f[^obt@`FbN
unsigned char chk_ob_buffer_not_full()
{
	unsigned char w1;
	unsigned char r1;
	w1 = ob_wp;
	r1 = ob_rp;
	w1 = w1	+ 1;	//̃ANZXŃ|C^v
	w1 = w1	& 0x7f;
	if(w1 == r1) return(0);
	return(1);
}

// getchar from	inbound	data buffer
unsigned char getc_ib_buffer ()
{
	unsigned char c;
	c =	ib_buffer[ib_rp];
	ib_rp++;
	ib_rp =	ib_rp &	0x7f;
	return c;
}

// putchar for inbound data	buffer
void putc_ib_buffer(char c)	 
{
	ib_buffer[ib_wp] = c ;
	ib_wp++;
	ib_wp =	ib_wp &	0x7f;
}

// getchar from	outbound data buffer
unsigned char getc_ob_buffer ()
{
	unsigned char c;
	c =	ob_buffer[ob_rp];
	ob_rp++;
	ob_rp =	ob_rp &	0x7f;
	return c;
}


// putchar for outbound	data buffer
void putc_ob_buffer(char c)	 
{
	ob_buffer[ob_wp] = c ;
	ob_wp++;
	ob_wp =	ob_wp &	0x7f;
}


void mySetLineCodingHandler(void)
{
}


/********************************************************************
 * Function:		void ProcessIO(void)
 *
 * PreCondition:	None
 *
 * Input:			None
 *
 * Output:			None
 *
 * Side	Effects:	None
 *
 * Overview:		This function is a place holder	for	other user
 *					routines. It is	a mixture of both USB and
 *					non-USB	tasks.
 *
 * Note:			None
 *******************************************************************/
void ProcessIO(void)
{	
	// User	Application	USB	tasks
	if((USBDeviceState < CONFIGURED_STATE)||(USBSuspendControl==1))	return;

	if (SIO_Out_Data_Rdy ==	0)	// only	check for new USB buffer if	the	old	SIO	buffer is
	{						  // empty.	 This will cause additional	USB	packets	to be NAK'd
		LastSIOOut = getsUSBUSART(SIO_Out_Data,64);	//until	the	buffer is free.
		if(LastSIOOut >	0)
		{	
			SIO_Out_Data_Rdy = 1;  // signal buffer	full
			SIOcp =	0;	// Reset the current position
		}
	}

	//Check	if one or more bytes are waiting in	the	physical UART transmit
	//queue.  If so, send it out the UART TX pin.
	if(SIO_Out_Data_Rdy	&& chk_ob_buffer_not_full())
	{
		//Hardware flow	control	not	being used.	 Just send the data.
		putc_ob_buffer(SIO_Out_Data[SIOcp]);
		++SIOcp;
		if (SIOcp == LastSIOOut)
			SIO_Out_Data_Rdy = 0;		
	}

	//Check	if we received a character over	the	physical UART, and we need
	//to buffer	it up for eventual transmission	to the USB host.
	if(chk_ib_buffer_not_empty() &&	(NextUSBOut	< (CDC_DATA_OUT_EP_SIZE	- 1)))
	{
		USB_Out_Buffer[NextUSBOut] = getc_ib_buffer();
		++NextUSBOut;
		USB_Out_Buffer[NextUSBOut] = 0;
	}
	
	//Check	if any bytes are waiting in	the	queue to send to the USB host.
	//If any bytes are waiting,	and	the	endpoint is	available, prepare to
	//send the USB packet to the host.
	if((USBUSARTIsTxTrfReady())	&& (NextUSBOut > 0))
	{
		putUSBUSART(&USB_Out_Buffer[0],	NextUSBOut);
		NextUSBOut = 0;
	}

	CDCTxService();

}//end ProcessIO


// ******************************************************************************************************
// ************** USB Callback Functions ****************************************************************
// ******************************************************************************************************
// The USB firmware	stack will call	the	callback functions USBCBxxx() in response to certain USB related
// events.	For	example, if	the	host PC	is powering	down, it will stop sending out Start of	Frame (SOF)
// packets to your device.	In response	to this, all USB devices are supposed to decrease their	power
// consumption from	the	USB	Vbus to	<2.5mA*	each.  The USB module detects this condition (which	according
// to the USB specifications is	3+ms of	no bus activity/SOF	packets) and then calls	the	USBCBSuspend()
// function.  You should modify	these callback functions to	take appropriate actions for each of these
// conditions.	For	example, in	the	USBCBSuspend(),	you	may	wish to	add	code that will decrease	power
// consumption from	Vbus to	<2.5mA (such as	by clock switching,	turning	off	LEDs, putting the
// microcontroller to sleep, etc.).	 Then, in the USBCBWakeFromSuspend() function, you may then	wish to
// add code	that undoes	the	power saving things	done in	the	USBCBSuspend() function.

// The USBCBSendResume() function is special, in that the USB stack	will not automatically call	this
// function.  This function	is meant to	be called from the application firmware	instead.  See the
// additional comments near	the	function.

// Note	*: The "usb_20.pdf"	specs indicate 500uA or	2.5mA, depending upon device classification. However,
// the USB-IF has officially issued	an ECN (engineering	change notice) changing	this to	2.5mA for all 
// devices.	 Make sure to re-download the latest specifications	to get all of the newest ECNs.

/******************************************************************************
 * Function:		void USBCBSuspend(void)
 *
 * PreCondition:	None
 *
 * Input:			None
 *
 * Output:			None
 *
 * Side	Effects:	None
 *
 * Overview:		Call back that is invoked when a USB suspend is	detected
 *
 * Note:			None
 *****************************************************************************/
void USBCBSuspend(void)
{
	//Example power	saving code.  Insert appropriate code here for the desired
	//application behavior.	 If	the	microcontroller	will be	put	to sleep, a
	//process similar to that shown	below may be used:
	
	//ConfigureIOPinsForLowPower();
	//SaveStateOfAllInterruptEnableBits();
	//DisableAllInterruptEnableBits();
	//EnableOnlyTheInterruptsWhichWillBeUsedToWakeTheMicro();	//should enable	at least USBActivityIF as a	wake source
	//Sleep();
	//RestoreStateOfAllPreviouslySavedInterruptEnableBits();	//Preferrably, this	should be done in the USBCBWakeFromSuspend() function instead.
	//RestoreIOPinsToNormal();									//Preferrably, this	should be done in the USBCBWakeFromSuspend() function instead.

	//IMPORTANT	NOTE: Do not clear the USBActivityIF (ACTVIF) bit here.	 This bit is 
	//cleared inside the usb_device.c file.	 Clearing USBActivityIF	here will cause	
	//things to	not	work as	intended.	
	

 
}



/******************************************************************************
 * Function:		void USBCBWakeFromSuspend(void)
 *
 * PreCondition:	None
 *
 * Input:			None
 *
 * Output:			None
 *
 * Side	Effects:	None
 *
 * Overview:		The	host may put USB peripheral	devices	in low power
 *					suspend	mode (by "sending" 3+ms	of idle).  Once	in suspend
 *					mode, the host may wake	the	device back	up by sending non-
 *					idle state signalling.
 *					
 *					This call back is invoked when a wakeup	from USB suspend 
 *					is detected.
 *
 * Note:			None
 *****************************************************************************/
void USBCBWakeFromSuspend(void)
{
	// If clock	switching or other power savings measures were taken when
	// executing the USBCBSuspend()	function, now would	be a good time to
	// switch back to normal full power	run	mode conditions.  The host allows
	// 10+ milliseconds	of wakeup time,	after which	the	device must	be 
	// fully back to normal, and capable of	receiving and processing USB
	// packets.	 In	order to do	this, the USB module must receive proper
	// clocking	(IE: 48MHz clock must be available to SIE for full speed USB
	// operation).	
	// Make	sure the selected oscillator settings are consistent with USB 
	// operation before	returning from this	function.
}

/********************************************************************
 * Function:		void USBCB_SOF_Handler(void)
 *
 * PreCondition:	None
 *
 * Input:			None
 *
 * Output:			None
 *
 * Side	Effects:	None
 *
 * Overview:		The	USB	host sends out a SOF packet	to full-speed
 *					devices	every 1	ms.	This interrupt may be useful
 *					for	isochronous	pipes. End designers should
 *					implement callback routine as necessary.
 *
 * Note:			None
 *******************************************************************/
void USBCB_SOF_Handler(void)
{
	// No need to clear	UIRbits.SOFIF to 0 here.
	// Callback	caller is already doing	that.
}

/*******************************************************************
 * Function:		void USBCBErrorHandler(void)
 *
 * PreCondition:	None
 *
 * Input:			None
 *
 * Output:			None
 *
 * Side	Effects:	None
 *
 * Overview:		The	purpose	of this	callback is	mainly for
 *					debugging during development. Check	UEIR to	see
 *					which error	causes the interrupt.
 *
 * Note:			None
 *******************************************************************/
void USBCBErrorHandler(void)
{
	// No need to clear	UEIR to	0 here.
	// Callback	caller is already doing	that.

	// Typically, user firmware	does not need to do	anything special
	// if a	USB	error occurs.  For example,	if the host	sends an OUT
	// packet to your device, but the packet gets corrupted	(ex:
	// because of a	bad	connection,	or the user	unplugs	the
	// USB cable during	the	transmission) this will	typically set
	// one or more USB error interrupt flags.  Nothing specific
	// needs to	be done	however, since the SIE will	automatically
	// send	a "NAK"	packet to the host.	 In	response to	this, the
	// host	will normally retry	to send	the	packet again, and no
	// data	loss occurs.  The system will typically	recover
	// automatically, without the need for application firmware
	// intervention.
	
	// Nevertheless, this callback function	is provided, such as
	// for debugging purposes.
}


/*******************************************************************
 * Function:		void USBCBCheckOtherReq(void)
 *
 * PreCondition:	None
 *
 * Input:			None
 *
 * Output:			None
 *
 * Side	Effects:	None
 *
 * Overview:		When SETUP packets arrive from the host, some
 *					firmware must process the request and respond
 *					appropriately to fulfill the request.  Some	of
 *					the	SETUP packets will be for standard
 *					USB	"chapter 9"	(as	in,	fulfilling chapter 9 of
 *					the	official USB specifications) requests, while
 *					others may be specific to the USB device class
 *					that is	being implemented.	For	example, a HID
 *					class device needs to be able to respond to
 *					"GET REPORT" type of requests.	This
 *					is not a standard USB chapter 9	request, and 
 *					therefore not handled by usb_device.c.	Instead
 *					this request should	be handled by class	specific 
 *					firmware, such as that contained in	usb_function_hid.c.
 *
 * Note:			None
 *******************************************************************/
void USBCBCheckOtherReq(void)
{
	USBCheckCDCRequest();
}//end


/*******************************************************************
 * Function:		void USBCBStdSetDscHandler(void)
 *
 * PreCondition:	None
 *
 * Input:			None
 *
 * Output:			None
 *
 * Side	Effects:	None
 *
 * Overview:		The	USBCBStdSetDscHandler()	callback function is
 *					called when	a SETUP, bRequest: SET_DESCRIPTOR request
 *					arrives.  Typically	SET_DESCRIPTOR requests	are
 *					not	used in	most applications, and it is
 *					optional to	support	this type of request.
 *
 * Note:			None
 *******************************************************************/
void USBCBStdSetDscHandler(void)
{
	// Must	claim session ownership	if supporting this request
}//end


/*******************************************************************
 * Function:		void USBCBInitEP(void)
 *
 * PreCondition:	None
 *
 * Input:			None
 *
 * Output:			None
 *
 * Side	Effects:	None
 *
 * Overview:		This function is called	when the device	becomes
 *					initialized, which occurs after	the	host sends a
 *					SET_CONFIGURATION (wValue not =	0) request.	 This 
 *					callback function should initialize	the	endpoints 
 *					for	the	device's usage according to	the	current	
 *					configuration.
 *
 * Note:			None
 *******************************************************************/
void USBCBInitEP(void)
{
	//Enable the CDC data endpoints
	CDCInitEP();
}

/********************************************************************
 * Function:		void USBCBSendResume(void)
 *
 * PreCondition:	None
 *
 * Input:			None
 *
 * Output:			None
 *
 * Side	Effects:	None
 *
 * Overview:		The	USB	specifications allow some types	of USB
 *					peripheral devices to wake up a	host PC	(such
 *					as if it is	in a low power suspend to RAM state).
 *					This can be	a very useful feature in some
 *					USB	applications, such as an Infrared remote
 *					control	receiver.  If a	user presses the "power"
 *					button on a	remote control,	it is nice that	the
 *					IR receiver	can	detect this	signalling,	and	then
 *					send a USB "command" to	the	PC to wake up.
 *					
 *					The	USBCBSendResume() "callback" function is used
 *					to send	this special USB signalling	which wakes	
 *					up the PC.	This function may be called	by
 *					application	firmware to	wake up	the	PC.	 This
 *					function will only be able to wake up the host if
 *					all	of the below are true:
 *					
 *					1.	The	USB	driver used	on the host	PC supports
 *						the	remote wakeup capability.
 *					2.	The	USB	configuration descriptor indicates
 *						the	device is remote wakeup	capable	in the
 *						bmAttributes field.
 *					3.	The	USB	host PC	is currently sleeping,
 *						and	has	previously sent	your device	a SET 
 *						FEATURE	setup packet which "armed" the
 *						remote wakeup capability.	
 *
 *					If the host	has	not	armed the device to	perform	remote wakeup,
 *					then this function will	return without actually	performing a
 *					remote wakeup sequence.	 This is the required behavior,	
 *					as a USB device	that has not been armed	to perform remote 
 *					wakeup must	not	drive remote wakeup	signalling onto	the	bus;
 *					doing so will cause	USB	compliance testing failure.
 *					
 *					This callback should send a	RESUME signal that
 *					has	the	period of 1-15ms.
 *
 * Note:			This function does nothing and returns quickly,	if the USB
 *					bus	and	host are not in	a suspended	condition, or are 
 *					otherwise not in a remote wakeup ready state.  Therefore, it
 *					is safe	to optionally call this	function regularly,	ex:	
 *					anytime	application	stimulus occurs, as	the	function will
 *					have no	effect,	until the bus really is	in a state ready
 *					to accept remote wakeup. 
 *
 *					When this function executes, it	may	perform	clock switching,
 *					depending upon the application specific	code in	
 *					USBCBWakeFromSuspend().	 This is needed, since the USB
 *					bus	will no	longer be suspended	by the time	this function
 *					returns.  Therefore, the USB module	will need to be	ready
 *					to receive traffic from	the	host.
 *
 *					The	modifiable section in this routine may be changed
 *					to meet	the	application	needs. Current implementation
 *					temporary blocks other functions from executing	for	a
 *					period of ~3-15	ms depending on	the	core frequency.
 *
 *					According to USB 2.0 specification section 7.1.7.7,
 *					"The remote	wakeup device must hold	the	resume signaling
 *					for	at least 1 ms but for no more than 15 ms."
 *					The	idea here is to	use	a delay	counter	loop, using	a
 *					common value that would	work over a	wide range of core
 *					frequencies.
 *					That value selected	is 1800. See table below:
 *					==========================================================
 *					Core Freq(MHz)		MIP			RESUME Signal Period (ms)
 *					==========================================================
 *						48				12			1.05
 *						 4				1			12.6
 *					==========================================================
 *					* These	timing could be	incorrect when using code
 *					  optimization or extended instruction mode,
 *					  or when having other interrupts enabled.
 *					  Make sure	to verify using	the	MPLAB SIM's	Stopwatch
 *					  and verify the actual	signal on an oscilloscope.
 *******************************************************************/
void USBCBSendResume(void)
{
	static WORD	delay_count;
	
	//First	verify that	the	host has armed us to perform remote	wakeup.
	//It does this by sending a	SET_FEATURE	request	to enable remote wakeup,
	//usually just before the host goes	to standby mode	(note: it will only
	//send this	SET_FEATURE	request	if the configuration descriptor	declares
	//the device as	remote wakeup capable, AND,	if the feature is enabled
	//on the host (ex: on Windows based	hosts, in the device manager 
	//properties page for the USB device, power	management tab,	the	
	//"Allow this device to	bring the computer out of standby."	checkbox 
	//should be	checked).
	if(USBGetRemoteWakeupStatus() == TRUE) 
	{
		//Verify that the USB bus is in	fact suspended,	before we send
		//remote wakeup	signalling.
		if(USBIsBusSuspended() == TRUE)
		{
			USBMaskInterrupts();
			
			//Clock	switch to settings consistent with normal USB operation.
			USBCBWakeFromSuspend();
			USBSuspendControl =	0; 
			USBBusIsSuspended =	FALSE;	//So we	don't execute this code	again, 
										//until	a new suspend condition	is detected.

			//Section 7.1.7.7 of the USB 2.0 specifications	indicates a	USB
			//device must continuously see 5ms+	of idle	on the bus,	before it sends
			//remote wakeup	signalling.	 One way to	be certain that	this parameter
			//gets met,	is to add a	2ms+ blocking delay	here (2ms plus at 
			//least	3ms	from bus idle to USBIsBusSuspended() ==	TRUE, yeilds
			//5ms+ total delay since start of idle).
			delay_count	= 3600U;		
			do
			{
				delay_count--;
			}while(delay_count);
			
			//Now drive	the	resume K-state signalling onto the USB bus.
			USBResumeControl = 1;		// Start RESUME	signaling
			delay_count	= 1800U;		// Set RESUME line for 1-13	ms
			do
			{
				delay_count--;
			}while(delay_count);
			USBResumeControl = 0;		//Finished driving resume signalling

			USBUnmaskInterrupts();
		}
	}
}


/*******************************************************************
 * Function:		void USBCBEP0DataReceived(void)
 *
 * PreCondition:	ENABLE_EP0_DATA_RECEIVED_CALLBACK must be
 *					defined	already	(in	usb_config.h)
 *
 * Input:			None
 *
 * Output:			None
 *
 * Side	Effects:	None
 *
 * Overview:		This function is called	whenever a EP0 data
 *					packet is received.	 This gives	the	user (and
 *					thus the various class examples	a way to get
 *					data that is received via the control endpoint.
 *					This function needs	to be used in conjunction
 *					with the USBCBCheckOtherReq() function since 
 *					the	USBCBCheckOtherReq() function is the apps
 *					method for getting the initial control transfer
 *					before the data	arrives.
 *
 * Note:			None
 *******************************************************************/
#if	defined(ENABLE_EP0_DATA_RECEIVED_CALLBACK)
void USBCBEP0DataReceived(void)
{
}
#endif

/*******************************************************************
 * Function:		BOOL USER_USB_CALLBACK_EVENT_HANDLER(
 *						  USB_EVENT	event, void	*pdata,	WORD size)
 *
 * PreCondition:	None
 *
 * Input:			USB_EVENT event	- the type of event
 *					void *pdata	- pointer to the event data
 *					WORD size -	size of	the	event data
 *
 * Output:			None
 *
 * Side	Effects:	None
 *
 * Overview:		This function is called	from the USB stack to
 *					notify a user application that a USB event
 *					occured.  This callback	is in interrupt	context
 *					when the USB_INTERRUPT option is selected.
 *
 * Note:			None
 *******************************************************************/
BOOL USER_USB_CALLBACK_EVENT_HANDLER(int event,	void *pdata, WORD size)
{
	switch(event)
	{
		case EVENT_TRANSFER:
			//Add application specific callback	task or	callback function here if desired.
			break;
		case EVENT_SOF:
			USBCB_SOF_Handler();
			break;
		case EVENT_SUSPEND:
			USBCBSuspend();
			break;
		case EVENT_RESUME:
			USBCBWakeFromSuspend();
			break;
		case EVENT_CONFIGURED: 
			USBCBInitEP();
			break;
		case EVENT_SET_DESCRIPTOR:
			USBCBStdSetDscHandler();
			break;
		case EVENT_EP0_REQUEST:
			USBCBCheckOtherReq();
			break;
		case EVENT_BUS_ERROR:
			USBCBErrorHandler();
			break;
		case EVENT_TRANSFER_TERMINATED:
			//Add application specific callback	task or	callback function here if desired.
			//The EVENT_TRANSFER_TERMINATED	event occurs when the host performs	a CLEAR
			//FEATURE (endpoint	halt) request on an	application	endpoint which was 
			//previously armed (UOWN was = 1).	Here would be a	good place to:
			//1.  Determine	which endpoint the transaction that	just got terminated	was	
			//		on,	by checking	the	handle value in	the	*pdata.
			//2.  Re-arm the endpoint if desired (typically	would be the case for OUT 
			//		endpoints).
			break;
		default:
			break;
	}	   
	return TRUE; 
}

/**	EOF	main.c *************************************************/
